# Events ## ListAuditLogs `client.Events.List(ctx, params) (*EntriesPage[EventListResponse], error)` **post** `/gitpod.v1.EventService/ListAuditLogs` Lists audit logs with filtering and pagination options. Use this method to: - View audit history - Track user actions - Monitor system changes ### Examples - List all logs: ```yaml pagination: pageSize: 20 ``` - Filter by actor: ```yaml filter: actorIds: ["d2c94c27-3b76-4a42-b88c-95a85e392c68"] actorPrincipals: ["PRINCIPAL_USER"] pagination: pageSize: 20 ``` - Filter by time range: ```yaml filter: from: "2024-01-01T00:00:00Z" to: "2024-02-01T00:00:00Z" pagination: pageSize: 20 ``` ### Parameters - `params EventListParams` - `Token param.Field[string]` Query param - `PageSize param.Field[int64]` Query param - `Filter param.Field[EventListParamsFilter]` Body param - `ActorIDs []string` - `ActorPrincipals []Principal` - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `From Time` from filters audit logs created at or after this timestamp (inclusive). - `SubjectIDs []string` - `SubjectTypes []ResourceType` - `const ResourceTypeUnspecified ResourceType = "RESOURCE_TYPE_UNSPECIFIED"` - `const ResourceTypeEnvironment ResourceType = "RESOURCE_TYPE_ENVIRONMENT"` - `const ResourceTypeRunner ResourceType = "RESOURCE_TYPE_RUNNER"` - `const ResourceTypeProject ResourceType = "RESOURCE_TYPE_PROJECT"` - `const ResourceTypeTask ResourceType = "RESOURCE_TYPE_TASK"` - `const ResourceTypeTaskExecution ResourceType = "RESOURCE_TYPE_TASK_EXECUTION"` - `const ResourceTypeService ResourceType = "RESOURCE_TYPE_SERVICE"` - `const ResourceTypeOrganization ResourceType = "RESOURCE_TYPE_ORGANIZATION"` - `const ResourceTypeUser ResourceType = "RESOURCE_TYPE_USER"` - `const ResourceTypeEnvironmentClass ResourceType = "RESOURCE_TYPE_ENVIRONMENT_CLASS"` - `const ResourceTypeRunnerScmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_SCM_INTEGRATION"` - `const ResourceTypeHostAuthenticationToken ResourceType = "RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN"` - `const ResourceTypeGroup ResourceType = "RESOURCE_TYPE_GROUP"` - `const ResourceTypePersonalAccessToken ResourceType = "RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN"` - `const ResourceTypeUserPreference ResourceType = "RESOURCE_TYPE_USER_PREFERENCE"` - `const ResourceTypeServiceAccount ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT"` - `const ResourceTypeSecret ResourceType = "RESOURCE_TYPE_SECRET"` - `const ResourceTypeSSOConfig ResourceType = "RESOURCE_TYPE_SSO_CONFIG"` - `const ResourceTypeDomainVerification ResourceType = "RESOURCE_TYPE_DOMAIN_VERIFICATION"` - `const ResourceTypeAgentExecution ResourceType = "RESOURCE_TYPE_AGENT_EXECUTION"` - `const ResourceTypeRunnerLlmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_LLM_INTEGRATION"` - `const ResourceTypeAgent ResourceType = "RESOURCE_TYPE_AGENT"` - `const ResourceTypeEnvironmentSession ResourceType = "RESOURCE_TYPE_ENVIRONMENT_SESSION"` - `const ResourceTypeUserSecret ResourceType = "RESOURCE_TYPE_USER_SECRET"` - `const ResourceTypeOrganizationPolicy ResourceType = "RESOURCE_TYPE_ORGANIZATION_POLICY"` - `const ResourceTypeOrganizationSecret ResourceType = "RESOURCE_TYPE_ORGANIZATION_SECRET"` - `const ResourceTypeProjectEnvironmentClass ResourceType = "RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS"` - `const ResourceTypeBilling ResourceType = "RESOURCE_TYPE_BILLING"` - `const ResourceTypePrompt ResourceType = "RESOURCE_TYPE_PROMPT"` - `const ResourceTypeCoupon ResourceType = "RESOURCE_TYPE_COUPON"` - `const ResourceTypeCouponRedemption ResourceType = "RESOURCE_TYPE_COUPON_REDEMPTION"` - `const ResourceTypeAccount ResourceType = "RESOURCE_TYPE_ACCOUNT"` - `const ResourceTypeIntegration ResourceType = "RESOURCE_TYPE_INTEGRATION"` - `const ResourceTypeWorkflow ResourceType = "RESOURCE_TYPE_WORKFLOW"` - `const ResourceTypeWorkflowExecution ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION"` - `const ResourceTypeWorkflowExecutionAction ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION"` - `const ResourceTypeSnapshot ResourceType = "RESOURCE_TYPE_SNAPSHOT"` - `const ResourceTypePrebuild ResourceType = "RESOURCE_TYPE_PREBUILD"` - `const ResourceTypeOrganizationLlmIntegration ResourceType = "RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION"` - `const ResourceTypeCustomDomain ResourceType = "RESOURCE_TYPE_CUSTOM_DOMAIN"` - `const ResourceTypeRoleAssignmentChanged ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED"` - `const ResourceTypeGroupMembershipChanged ResourceType = "RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED"` - `const ResourceTypeWebhook ResourceType = "RESOURCE_TYPE_WEBHOOK"` - `const ResourceTypeScimConfiguration ResourceType = "RESOURCE_TYPE_SCIM_CONFIGURATION"` - `const ResourceTypeServiceAccountSecret ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET"` - `const ResourceTypeAnnouncementBanner ResourceType = "RESOURCE_TYPE_ANNOUNCEMENT_BANNER"` - `const ResourceTypeServiceAccountToken ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN"` - `const ResourceTypeRoleAssignment ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT"` - `const ResourceTypeWarmPool ResourceType = "RESOURCE_TYPE_WARM_POOL"` - `const ResourceTypeNotification ResourceType = "RESOURCE_TYPE_NOTIFICATION"` - `To Time` to filters audit logs created before this timestamp (exclusive). - `Pagination param.Field[EventListParamsPagination]` Body param: pagination contains the pagination options for listing audit logs - `Token string` Token for the next set of results that was returned as next_token of a PaginationResponse - `PageSize int64` Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. - `Sort param.Field[Sort]` Body param: sort specifies the order of results. When unspecified, results are sorted by creation time descending (newest first). Supported sort fields: createdAt. ### Returns - `type EventListResponse struct{…}` - `ID string` - `Action string` - `ActorID string` - `ActorPrincipal Principal` - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `CreatedAt Time` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `SubjectID string` - `SubjectType ResourceType` - `const ResourceTypeUnspecified ResourceType = "RESOURCE_TYPE_UNSPECIFIED"` - `const ResourceTypeEnvironment ResourceType = "RESOURCE_TYPE_ENVIRONMENT"` - `const ResourceTypeRunner ResourceType = "RESOURCE_TYPE_RUNNER"` - `const ResourceTypeProject ResourceType = "RESOURCE_TYPE_PROJECT"` - `const ResourceTypeTask ResourceType = "RESOURCE_TYPE_TASK"` - `const ResourceTypeTaskExecution ResourceType = "RESOURCE_TYPE_TASK_EXECUTION"` - `const ResourceTypeService ResourceType = "RESOURCE_TYPE_SERVICE"` - `const ResourceTypeOrganization ResourceType = "RESOURCE_TYPE_ORGANIZATION"` - `const ResourceTypeUser ResourceType = "RESOURCE_TYPE_USER"` - `const ResourceTypeEnvironmentClass ResourceType = "RESOURCE_TYPE_ENVIRONMENT_CLASS"` - `const ResourceTypeRunnerScmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_SCM_INTEGRATION"` - `const ResourceTypeHostAuthenticationToken ResourceType = "RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN"` - `const ResourceTypeGroup ResourceType = "RESOURCE_TYPE_GROUP"` - `const ResourceTypePersonalAccessToken ResourceType = "RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN"` - `const ResourceTypeUserPreference ResourceType = "RESOURCE_TYPE_USER_PREFERENCE"` - `const ResourceTypeServiceAccount ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT"` - `const ResourceTypeSecret ResourceType = "RESOURCE_TYPE_SECRET"` - `const ResourceTypeSSOConfig ResourceType = "RESOURCE_TYPE_SSO_CONFIG"` - `const ResourceTypeDomainVerification ResourceType = "RESOURCE_TYPE_DOMAIN_VERIFICATION"` - `const ResourceTypeAgentExecution ResourceType = "RESOURCE_TYPE_AGENT_EXECUTION"` - `const ResourceTypeRunnerLlmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_LLM_INTEGRATION"` - `const ResourceTypeAgent ResourceType = "RESOURCE_TYPE_AGENT"` - `const ResourceTypeEnvironmentSession ResourceType = "RESOURCE_TYPE_ENVIRONMENT_SESSION"` - `const ResourceTypeUserSecret ResourceType = "RESOURCE_TYPE_USER_SECRET"` - `const ResourceTypeOrganizationPolicy ResourceType = "RESOURCE_TYPE_ORGANIZATION_POLICY"` - `const ResourceTypeOrganizationSecret ResourceType = "RESOURCE_TYPE_ORGANIZATION_SECRET"` - `const ResourceTypeProjectEnvironmentClass ResourceType = "RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS"` - `const ResourceTypeBilling ResourceType = "RESOURCE_TYPE_BILLING"` - `const ResourceTypePrompt ResourceType = "RESOURCE_TYPE_PROMPT"` - `const ResourceTypeCoupon ResourceType = "RESOURCE_TYPE_COUPON"` - `const ResourceTypeCouponRedemption ResourceType = "RESOURCE_TYPE_COUPON_REDEMPTION"` - `const ResourceTypeAccount ResourceType = "RESOURCE_TYPE_ACCOUNT"` - `const ResourceTypeIntegration ResourceType = "RESOURCE_TYPE_INTEGRATION"` - `const ResourceTypeWorkflow ResourceType = "RESOURCE_TYPE_WORKFLOW"` - `const ResourceTypeWorkflowExecution ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION"` - `const ResourceTypeWorkflowExecutionAction ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION"` - `const ResourceTypeSnapshot ResourceType = "RESOURCE_TYPE_SNAPSHOT"` - `const ResourceTypePrebuild ResourceType = "RESOURCE_TYPE_PREBUILD"` - `const ResourceTypeOrganizationLlmIntegration ResourceType = "RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION"` - `const ResourceTypeCustomDomain ResourceType = "RESOURCE_TYPE_CUSTOM_DOMAIN"` - `const ResourceTypeRoleAssignmentChanged ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED"` - `const ResourceTypeGroupMembershipChanged ResourceType = "RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED"` - `const ResourceTypeWebhook ResourceType = "RESOURCE_TYPE_WEBHOOK"` - `const ResourceTypeScimConfiguration ResourceType = "RESOURCE_TYPE_SCIM_CONFIGURATION"` - `const ResourceTypeServiceAccountSecret ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET"` - `const ResourceTypeAnnouncementBanner ResourceType = "RESOURCE_TYPE_ANNOUNCEMENT_BANNER"` - `const ResourceTypeServiceAccountToken ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN"` - `const ResourceTypeRoleAssignment ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT"` - `const ResourceTypeWarmPool ResourceType = "RESOURCE_TYPE_WARM_POOL"` - `const ResourceTypeNotification ResourceType = "RESOURCE_TYPE_NOTIFICATION"` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" "github.com/gitpod-io/gitpod-sdk-go/shared" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) page, err := client.Events.List(context.TODO(), gitpod.EventListParams{ Filter: gitpod.F(gitpod.EventListParamsFilter{ ActorIDs: gitpod.F([]string{"d2c94c27-3b76-4a42-b88c-95a85e392c68"}), ActorPrincipals: gitpod.F([]shared.Principal{shared.PrincipalUser}), }), Pagination: gitpod.F(gitpod.EventListParamsPagination{ PageSize: gitpod.F(int64(20)), }), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "entries": [ { "id": "id", "action": "action", "actorId": "actorId", "actorPrincipal": "PRINCIPAL_UNSPECIFIED", "createdAt": "2019-12-27T18:11:19.117Z", "subjectId": "subjectId", "subjectType": "RESOURCE_TYPE_UNSPECIFIED" } ], "pagination": { "nextToken": "nextToken" } } ``` ## WatchEvents `client.Events.Watch(ctx, body) (*EventWatchResponse, error)` **post** `/gitpod.v1.EventService/WatchEvents` Streams events for all projects, runners, environments, tasks, and services based on the specified scope. Use this method to: - Monitor resource changes in real-time - Track system events - Receive notifications The scope parameter determines which events to watch: - Organization scope (default): Watch all organization-wide events including projects, runners and environments. Task and service events are not included. Use by setting organization=true or omitting the scope. - Environment scope: Watch events for a specific environment, including its tasks, task executions, and services. Use by setting environment_id to the UUID of the environment to watch. ### Parameters - `body EventWatchParams` - `EnvironmentID param.Field[string]` Environment scope produces events for the environment itself, all tasks, task executions, and services associated with that environment. - `Organization param.Field[bool]` Organization scope produces events for all projects, runners and environments the caller can see within their organization. No task, task execution or service events are produed. - `ResourceTypeFilters param.Field[[]EventWatchParamsResourceTypeFilter]` Filters to limit which events are delivered on organization-scoped streams. When empty, all events for the scope are delivered. When populated, only events matching at least one filter entry are forwarded. Not supported for environment-scoped streams; setting this field returns an error. - `CreatorIDs []string` If non-empty, only events where the resource was created by one of these user IDs are delivered. Skipped for DELETE operations (creator info is unavailable after deletion). Events with no creator information are skipped when this filter is set (fail-closed). - `ResourceIDs []string` If non-empty, only events for these specific resource IDs are delivered. - `ResourceType ResourceType` The resource type to filter for. - `const ResourceTypeUnspecified ResourceType = "RESOURCE_TYPE_UNSPECIFIED"` - `const ResourceTypeEnvironment ResourceType = "RESOURCE_TYPE_ENVIRONMENT"` - `const ResourceTypeRunner ResourceType = "RESOURCE_TYPE_RUNNER"` - `const ResourceTypeProject ResourceType = "RESOURCE_TYPE_PROJECT"` - `const ResourceTypeTask ResourceType = "RESOURCE_TYPE_TASK"` - `const ResourceTypeTaskExecution ResourceType = "RESOURCE_TYPE_TASK_EXECUTION"` - `const ResourceTypeService ResourceType = "RESOURCE_TYPE_SERVICE"` - `const ResourceTypeOrganization ResourceType = "RESOURCE_TYPE_ORGANIZATION"` - `const ResourceTypeUser ResourceType = "RESOURCE_TYPE_USER"` - `const ResourceTypeEnvironmentClass ResourceType = "RESOURCE_TYPE_ENVIRONMENT_CLASS"` - `const ResourceTypeRunnerScmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_SCM_INTEGRATION"` - `const ResourceTypeHostAuthenticationToken ResourceType = "RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN"` - `const ResourceTypeGroup ResourceType = "RESOURCE_TYPE_GROUP"` - `const ResourceTypePersonalAccessToken ResourceType = "RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN"` - `const ResourceTypeUserPreference ResourceType = "RESOURCE_TYPE_USER_PREFERENCE"` - `const ResourceTypeServiceAccount ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT"` - `const ResourceTypeSecret ResourceType = "RESOURCE_TYPE_SECRET"` - `const ResourceTypeSSOConfig ResourceType = "RESOURCE_TYPE_SSO_CONFIG"` - `const ResourceTypeDomainVerification ResourceType = "RESOURCE_TYPE_DOMAIN_VERIFICATION"` - `const ResourceTypeAgentExecution ResourceType = "RESOURCE_TYPE_AGENT_EXECUTION"` - `const ResourceTypeRunnerLlmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_LLM_INTEGRATION"` - `const ResourceTypeAgent ResourceType = "RESOURCE_TYPE_AGENT"` - `const ResourceTypeEnvironmentSession ResourceType = "RESOURCE_TYPE_ENVIRONMENT_SESSION"` - `const ResourceTypeUserSecret ResourceType = "RESOURCE_TYPE_USER_SECRET"` - `const ResourceTypeOrganizationPolicy ResourceType = "RESOURCE_TYPE_ORGANIZATION_POLICY"` - `const ResourceTypeOrganizationSecret ResourceType = "RESOURCE_TYPE_ORGANIZATION_SECRET"` - `const ResourceTypeProjectEnvironmentClass ResourceType = "RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS"` - `const ResourceTypeBilling ResourceType = "RESOURCE_TYPE_BILLING"` - `const ResourceTypePrompt ResourceType = "RESOURCE_TYPE_PROMPT"` - `const ResourceTypeCoupon ResourceType = "RESOURCE_TYPE_COUPON"` - `const ResourceTypeCouponRedemption ResourceType = "RESOURCE_TYPE_COUPON_REDEMPTION"` - `const ResourceTypeAccount ResourceType = "RESOURCE_TYPE_ACCOUNT"` - `const ResourceTypeIntegration ResourceType = "RESOURCE_TYPE_INTEGRATION"` - `const ResourceTypeWorkflow ResourceType = "RESOURCE_TYPE_WORKFLOW"` - `const ResourceTypeWorkflowExecution ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION"` - `const ResourceTypeWorkflowExecutionAction ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION"` - `const ResourceTypeSnapshot ResourceType = "RESOURCE_TYPE_SNAPSHOT"` - `const ResourceTypePrebuild ResourceType = "RESOURCE_TYPE_PREBUILD"` - `const ResourceTypeOrganizationLlmIntegration ResourceType = "RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION"` - `const ResourceTypeCustomDomain ResourceType = "RESOURCE_TYPE_CUSTOM_DOMAIN"` - `const ResourceTypeRoleAssignmentChanged ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED"` - `const ResourceTypeGroupMembershipChanged ResourceType = "RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED"` - `const ResourceTypeWebhook ResourceType = "RESOURCE_TYPE_WEBHOOK"` - `const ResourceTypeScimConfiguration ResourceType = "RESOURCE_TYPE_SCIM_CONFIGURATION"` - `const ResourceTypeServiceAccountSecret ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET"` - `const ResourceTypeAnnouncementBanner ResourceType = "RESOURCE_TYPE_ANNOUNCEMENT_BANNER"` - `const ResourceTypeServiceAccountToken ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN"` - `const ResourceTypeRoleAssignment ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT"` - `const ResourceTypeWarmPool ResourceType = "RESOURCE_TYPE_WARM_POOL"` - `const ResourceTypeNotification ResourceType = "RESOURCE_TYPE_NOTIFICATION"` ### Returns - `type EventWatchResponse struct{…}` - `Operation ResourceOperation` - `const ResourceOperationUnspecified ResourceOperation = "RESOURCE_OPERATION_UNSPECIFIED"` - `const ResourceOperationCreate ResourceOperation = "RESOURCE_OPERATION_CREATE"` - `const ResourceOperationUpdate ResourceOperation = "RESOURCE_OPERATION_UPDATE"` - `const ResourceOperationDelete ResourceOperation = "RESOURCE_OPERATION_DELETE"` - `const ResourceOperationUpdateStatus ResourceOperation = "RESOURCE_OPERATION_UPDATE_STATUS"` - `ResourceID string` - `ResourceType ResourceType` - `const ResourceTypeUnspecified ResourceType = "RESOURCE_TYPE_UNSPECIFIED"` - `const ResourceTypeEnvironment ResourceType = "RESOURCE_TYPE_ENVIRONMENT"` - `const ResourceTypeRunner ResourceType = "RESOURCE_TYPE_RUNNER"` - `const ResourceTypeProject ResourceType = "RESOURCE_TYPE_PROJECT"` - `const ResourceTypeTask ResourceType = "RESOURCE_TYPE_TASK"` - `const ResourceTypeTaskExecution ResourceType = "RESOURCE_TYPE_TASK_EXECUTION"` - `const ResourceTypeService ResourceType = "RESOURCE_TYPE_SERVICE"` - `const ResourceTypeOrganization ResourceType = "RESOURCE_TYPE_ORGANIZATION"` - `const ResourceTypeUser ResourceType = "RESOURCE_TYPE_USER"` - `const ResourceTypeEnvironmentClass ResourceType = "RESOURCE_TYPE_ENVIRONMENT_CLASS"` - `const ResourceTypeRunnerScmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_SCM_INTEGRATION"` - `const ResourceTypeHostAuthenticationToken ResourceType = "RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN"` - `const ResourceTypeGroup ResourceType = "RESOURCE_TYPE_GROUP"` - `const ResourceTypePersonalAccessToken ResourceType = "RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN"` - `const ResourceTypeUserPreference ResourceType = "RESOURCE_TYPE_USER_PREFERENCE"` - `const ResourceTypeServiceAccount ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT"` - `const ResourceTypeSecret ResourceType = "RESOURCE_TYPE_SECRET"` - `const ResourceTypeSSOConfig ResourceType = "RESOURCE_TYPE_SSO_CONFIG"` - `const ResourceTypeDomainVerification ResourceType = "RESOURCE_TYPE_DOMAIN_VERIFICATION"` - `const ResourceTypeAgentExecution ResourceType = "RESOURCE_TYPE_AGENT_EXECUTION"` - `const ResourceTypeRunnerLlmIntegration ResourceType = "RESOURCE_TYPE_RUNNER_LLM_INTEGRATION"` - `const ResourceTypeAgent ResourceType = "RESOURCE_TYPE_AGENT"` - `const ResourceTypeEnvironmentSession ResourceType = "RESOURCE_TYPE_ENVIRONMENT_SESSION"` - `const ResourceTypeUserSecret ResourceType = "RESOURCE_TYPE_USER_SECRET"` - `const ResourceTypeOrganizationPolicy ResourceType = "RESOURCE_TYPE_ORGANIZATION_POLICY"` - `const ResourceTypeOrganizationSecret ResourceType = "RESOURCE_TYPE_ORGANIZATION_SECRET"` - `const ResourceTypeProjectEnvironmentClass ResourceType = "RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS"` - `const ResourceTypeBilling ResourceType = "RESOURCE_TYPE_BILLING"` - `const ResourceTypePrompt ResourceType = "RESOURCE_TYPE_PROMPT"` - `const ResourceTypeCoupon ResourceType = "RESOURCE_TYPE_COUPON"` - `const ResourceTypeCouponRedemption ResourceType = "RESOURCE_TYPE_COUPON_REDEMPTION"` - `const ResourceTypeAccount ResourceType = "RESOURCE_TYPE_ACCOUNT"` - `const ResourceTypeIntegration ResourceType = "RESOURCE_TYPE_INTEGRATION"` - `const ResourceTypeWorkflow ResourceType = "RESOURCE_TYPE_WORKFLOW"` - `const ResourceTypeWorkflowExecution ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION"` - `const ResourceTypeWorkflowExecutionAction ResourceType = "RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION"` - `const ResourceTypeSnapshot ResourceType = "RESOURCE_TYPE_SNAPSHOT"` - `const ResourceTypePrebuild ResourceType = "RESOURCE_TYPE_PREBUILD"` - `const ResourceTypeOrganizationLlmIntegration ResourceType = "RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION"` - `const ResourceTypeCustomDomain ResourceType = "RESOURCE_TYPE_CUSTOM_DOMAIN"` - `const ResourceTypeRoleAssignmentChanged ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED"` - `const ResourceTypeGroupMembershipChanged ResourceType = "RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED"` - `const ResourceTypeWebhook ResourceType = "RESOURCE_TYPE_WEBHOOK"` - `const ResourceTypeScimConfiguration ResourceType = "RESOURCE_TYPE_SCIM_CONFIGURATION"` - `const ResourceTypeServiceAccountSecret ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET"` - `const ResourceTypeAnnouncementBanner ResourceType = "RESOURCE_TYPE_ANNOUNCEMENT_BANNER"` - `const ResourceTypeServiceAccountToken ResourceType = "RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN"` - `const ResourceTypeRoleAssignment ResourceType = "RESOURCE_TYPE_ROLE_ASSIGNMENT"` - `const ResourceTypeWarmPool ResourceType = "RESOURCE_TYPE_WARM_POOL"` - `const ResourceTypeNotification ResourceType = "RESOURCE_TYPE_NOTIFICATION"` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) stream := client.Events.WatchStreaming(context.TODO(), gitpod.EventWatchParams{ }) for stream.Next() { fmt.Printf("%+v\n", stream.Current()) } err := stream.Err() if err != nil { panic(err.Error()) } } ``` ## Domain Types ### Resource Operation - `type ResourceOperation string` - `const ResourceOperationUnspecified ResourceOperation = "RESOURCE_OPERATION_UNSPECIFIED"` - `const ResourceOperationCreate ResourceOperation = "RESOURCE_OPERATION_CREATE"` - `const ResourceOperationUpdate ResourceOperation = "RESOURCE_OPERATION_UPDATE"` - `const ResourceOperationDelete ResourceOperation = "RESOURCE_OPERATION_DELETE"` - `const ResourceOperationUpdateStatus ResourceOperation = "RESOURCE_OPERATION_UPDATE_STATUS"`